#!/usr/bin/perl

# fix_profile_plot_label.pl
# Modified from UCAR/ATD ps2eps.pl included with grid2ps
# Script to fix a ps profile file
# generated by plotced 

require "getopt.pl";

# MAKE SURE THE USAGE IS CORRECT
# -o=output text file
if ($#ARGV<0) {
   print "\nUSAGE: fix_profile_plot.pl\n";
   print "\t-i 'postscript filename'\n";
   print "\t-o 'outout postscript filename'\n";
   print "\t-a 'azimuth in deg (int)''\n";
   print "\t-help 'help'\n\n";
   exit();
} else {
   &Getopt('ioaht');
}

if ($opt_h eq "elp") {&print_help;}

&get_az;

&generate_out; 
#**************************************************
sub print_help {

   # Print option info
   print "\n   fix_profile_plot.pl changes Y= label to azimuth\n";
   print "OPTIONS:\n";
   print "\t-i:\tName of postscript file ";
   print "generated in plotced or grid2ps\n\n";
   print "\t-o:\tName of output ps file\n\n";
   print "\t-l:\tazimuth.\n";
   print "\tExample:  fix_profile_plot.pl -i test.ps -o new_test.ps -a 186\n";
   print "\tNote: the azimuth should be intger\n";
   exit();
   
}
#******************************************
sub get_az {

   if ($opt_a ne "") {
	$az = $opt_a;
   } else {
      print "Warning: no az specified...";
      print "using default az 0 \n";
      $az = '0';
   } # endif

}
#******************************************
sub generate_out {

   open (PS, "$opt_i") || die "cannot open $opt_i";
   open (EPS, ">$opt_o") || die "cannot open $opt_o";

   $date = `date`;
   chop($date);
   while (<PS>) {
      chop;
# Note use of \( because ( is special character in regular experession
      if (/^box_w box_h sp_horiz_text add 0 \(Y=  0.00\)4 1 text_pos/) {
#	print "changing y=0.0 azis label \n";
	 print EPS "box_w box_h sp_horiz_text add 0 (Azimuth: ";
	 print EPS " $az deg";
	 print EPS ")4 1 text_pos \n";
      } elsif (/^box_w box_h sp_horiz_text add 0 \(Y=-15.00\)4 1 text_pos/) {
#	print "changing y=-15.0 azis label \n";
	 print EPS "box_w box_h sp_horiz_text add 0 (Azimuth: ";
	 print EPS " $az deg";
	 print EPS ")4 1 text_pos \n";
      } elsif (/^box_w box_h sp_horiz_text add 0 \(Y= 15.00\)4 1 text_pos/) {
#	print "changing y=15.0 azis label \n";
	 print EPS "box_w box_h sp_horiz_text add 0 (Azimuth: ";
	 print EPS " $az deg";
	 print EPS ")4 1 text_pos \n";
      } else {
         print EPS "$_\n";
      }
   }
   print EPS "%%EOF\n";

   close(PS);
   close(EPS);

}
