	program browse_iris_sweeps

C browse sweeps
	parameter(max_rays = 800, max_gates = 2048)

C set this to 0 if no imagemagic finctions avail
	parameter(ImageMagic = 1)
C IRiS files probalby only hold 5 or less but  I keep it  big just in case...

	character*1 batch_flag
	character*1 option
	integer*4 swapped, read_stuff
	character*80 sweep_fn, list_fn
Cout	integer*4 swp_lu
	integer*8 swp_lu
	integer list_lu

	integer*4 iostat
	integer*4 nrem, tot_read
	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
					
	type ( struct_hdr) str_hdr
	type ( product_config) prod_conf
	type ( product_end) prod_end
	type ( ingest_configuration) i_config
	type ( task_sched_info) t_sched
	type ( task_dsp_info) t_dsp
	type ( task_calib_info) t_calib
	type ( task_range_info) t_range
	type ( task_scan_info) t_scan

	type ( ymds_time) start_time_str
	type ( ymds_time) end_time_str
	
	type ( task_misc_info) t_misc
	type ( task_end_info) t_end

	type ( task_rhi_scan_info) t_rhi
	type ( task_ppi_scan_info) t_ppi
	
	type ( ingest_data_hdr) idh(MAX_FIELDS) ! /* should be more general! */
	type ( raw_prod_bhdr) rpbh
	type ( ray_hdr) rh(max_rays)
	type ( TDR_hdr) air_hdr(max_rays)

C and here are the arrays for the pther data types:
	real dbz(max_gates), dop(max_gates), wid(max_gates)
C and 3 arrays i can use for displaying sweeps
	real dbz_sweep(max_gates, max_rays)
	real dop_sweep(max_gates, max_rays)
	real spw_sweep(max_gates, max_rays)
	real az_el( 2, max_rays)

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

	character*80 radar_fn
	character*4 time_string


c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	include "hrd_radar_common_blocks.f"
	logical tail_fore, tail_aft
	logical french_antenna
	character*1 antenna_type
C arrays itc for display on C window.
	      parameter(max_x = 500, max_y = 480)
C arrays of interpolated data:
	integer ilog_lu
	integer*2 dBZ_int(max_x, max_y)
	integer*2 dop_int(max_x, max_y)
	integer*2 spw_int(max_x, max_y)
C my window structure only requires 188 bytes on
C 32 bit machines, but trquires 344 bytes on 64
C bit machines like helios. Thsi is because my 
C structure holds several pointers ti Xlib structures.
c on 64 bit machines pointers are 8 bytes...duh
	integer*4 dbz_window(86)
	integer*4 dop_window(86)
	integer*4 spw_window(86)

	character*8 radnm, radar_id*4, project*20 
	character*32 display_label, window_label(3)
	character*32 tif_file_name
C array of flags to select data
	integer data_sel_flags(3)
C default data types to load
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_WIDTH2

C
	list_lu = 23
	ilog_lu = 6
	bad_val = -999.0
	ambiguous = -999.9
	too_noisy = -200.0
C
	make_tif = 0
	batch_flag = "N"

	
	read_stuff = 0 ! set to  1 to get massive dump of info
	call getarg(1, list_fn)
	if(list_fn .eq. ' ')then
	  write(6,*)' IRIS radar  files list: '
	  read(5,'(a)') list_fn
	end if
	open(list_lu,file=list_fn,form='formatted',status='old',
     +		err = 990)
C
	call getarg(2, option )
	if(option .eq. ' ') then
		batch_flag = 'N'
	else
		if(option.eq.'t')then
		   make_tif = 1
		else if(option.eq.'b')then
		    batch_flag = 'b'
		end if
		call getarg(3, option )
		if(option.eq.'t')then
		   make_tif = 1
		else if(option.eq.'b')then
		    batch_flag = 'b'
		end if
	end if
C
C first open window on scren
	idata_type = 2 ! not 1, rvp8 stores dbz
	window_label(1) = 'dBZ IRIS/RVP8 sweep'//char(0)
	call rasx_open_window( dbz_window, iw_error,window_label(1))
	if(iw_error .ne. 1) then
		write(6,*)' rasx_open_window error # ',error
		stop
	end if
	window_label(2) = 'Doppler IRIS/RVP8 sweep'//char(0)
	call rasx_open_window( dop_window, iw_error,window_label(2))
	if(iw_error .ne. 1) then
		write(6,*)' rasx_open_window error # ',error
		stop
	end if
	window_label(3) = 'Spectral Width'//char(0)
	call rasx_open_window( spw_window, iw_error,window_label(3))
	if(iw_error .ne. 1) then
		write(6,*)' rasx_open_window error # ',error
		stop
	end if
	if( batch_flag .ne. 'b' ) then
		write(6,*)' position window '
		read(5,*)
	end if
  
c
10	read(list_lu,*,end=900,err=900)sweep_fn
	call open_iris_file(swp_lu, sweep_fn, iostat)
	write(6,*)iostat,' iostat opening ', sweep_fn
	write(6,*)' returned file pointer ', swp_lu
	if(iostat .ne. 1) then
		stop ' adios '
	else
		write(6,*) "Opened sweep file", sweep_fn
	end if

	call check_byte_swapping(swp_lu, swapped)
c
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
	write(6,*)' read first record'
	call read_product_hdr(6, prod_conf, prod_end)

	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_sched, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	tot_read =  2 * BLK_LENGTH
	write(6,*)' Read record 2'

	call read_task_hdr(6, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
	wavelength= t_misc%wavelength * 0.0001
	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )

	write(6, *)"Myquist velocity ",vel_nyq," m/s"


C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.

	num_sweeps = t_scan%num_sweeps
	num_fields = i_config%num_assoc_files
	write(6,*)'mun fields, sweeps ',num_fields, num_sweeps
	isweep = 0
cout	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
4321	isweep = isweep + 1
	   write(6,*)" *** Sweep # ",isweep," of file ",sweep_fn
C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	  num_rays = idh(num_fields)%expected_num_rays
	  avg_roll = 0.0
C finally read the rays and expand the data, including the extended headers
C some rays may have 0 bins, so i need num_bins to hold
C longest ray # of bins
	  num_bins = 0 
	  num_good_rays = 1
	  do i = 1, num_rays
	   write( 6, '("ray # ", i3, 58("=") )'), i
	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dbz, dop, wid, 
     +		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)
	   if(io_error .ne. 1) then
		write(6,*)'read ray i/o err ',io_error
		go to 333
	   else
		num_good_rays = num_good_rays + 1
	   end if
c
c this loads attidtde and nav indo into HRD common blocks
	   call read_TDR_hdr(lu, air_hdr(i) )
	   avg_roll = avg_roll + roll

	    if(rh(i)%num_bins_in_ray .gt. num_bins) then
		num_bins = rh(i)%num_bins_in_ray
	    end if
c load sweep arrays for later display
	   do ib = 1, rh(i)%num_bins_in_ray
		dbz_sweep( ib, i) = dbz(ib)
		dop_sweep(ib, i) = dop(ib)
		spw_sweep( ib, i) = wid( ib )
	   end do
	   do ib = rh(i)%num_bins_in_ray +1, max_gates
		dbz_sweep( ib, i) = bad_val
		dop_sweep(ib, i) = bad_val
		spw_sweep( ib, i) = bad_val
	   end do
C assign az el depending on whether Tail or Lower Fuselage

C code to insert if my display code to take care of
C Lower Fuselage and Tail az and el angles
	if(t_scan%antenna_scan_mode .eq. 7)then
C "Full RHI" mode _. tail radar
	   az_el(1, i) = bam16_TO_de g(rh(i)%el_beg )
	   az_el(2, i) = bam16_TO_de g(rh(i)%az_beg )
C the sigmet/rvp8 tail radar  spits out rotation angles in math angels: 0 deg starboard, 90 p alin the rail
C fin, 180 deg port and 270 down.
C Here i convert to nav angles so my old display code works
	   az_el(1,i) = 90.0 - az_el(1,i)
C correct the rotation angle for thr roll angle
	   az_el(1,i) = az_el(1,i) + roll
	   if(az_el(1,i) .lt. 0.0)then
		az_el(1,i) = az_el(1,i) + 360.0
	   end if


	else if(t_scan%antenna_scan_mode .eq. 4) then
C "Contunuous PPi -> Lower Fuselage radar, already in earthe rel
C angles in AOC implementation. Az 0 N, 90 W and el postive above horizontal

	   az_el(1, i) = bam16_TO_de g(rh(i)%az_beg )
	   az_el(2, i) = bam16_TO_de g(rh(i)%el_beg )
	end if
C
	   call get_ray_min_max(dbz, num_bins, bad_val,dbz_min, dbz_max)
	   call get_ray_min_max(dop, num_bins, bad_val,dop_min, dop_max)
	   call get_ray_min_max(wid, num_bins, bad_val,wid_min, wid_max)
	   write(6, 111)i, az_el(1,i), az_el(2,i), dbz_min, dbz_max,
     +		dop_min, dop_max, wid_min, wid_max
111	   format('Ray # ',i3, 1x, f7.2, 1x, f6.2, 1x,6(f6.2,1x) )

	  end do ! rays loop

	  if(isweep .lt. num_sweeps) then
		call skip_iris_words(swp_lu,nrem)
	  end if
cout	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
333	num_rays = num_good_rays
	  avg_roll = avg_roll / num_rays

	if(isweep .ge. num_sweeps) then
		call close_iris_file(swp_lu)
	end if
c intwepolate to cartesian arrays for display
	imax = 400
	jmax = imax
	sx = 0.25
	sy = sx
	xdis = 50.0
	ydis = 50.0
	ixl = 10 
	iyb = 480 - jmax -10
	elmin = -90
	elmax = 90
	do j = 1, jmax
		do i = 1, imax
			dBZ_int(i, j) = -1
		end do
	end do
C no interpoaltion is done, so I pass dbz and we
C need data type 2.  06/30/2011
	idata_type = 2
	rmx = radiita(num_bins)
	rdel_z = 0.0
	nmosm = 0
	itflg = 0
	iersm = 6
	rmx = radiita( num_bins)
	call rvp8_nointerp_convt(idata_type, elmin, elmax,
     +		dBZ_int, max_x, max_y, ilog_lu,
     +		az_el, dbz_sweep, max_gates, num_bins, 
     +		num_rays, iersm,
     +		imax, jmax, sx, sy, xdis, ydis, rlat, rlon,
     +		 slat, slon, rmx, rdel_z, time, nmosm, itflg,
     +		radiita, bad_val)

	write(6,*)' Finished dBz interpolation.' 
c change data type to non-dBA
	idata_type = 2

	call rvp8_nointerp_convt(idata_type, elmin, elmax,
     +		dop_int, max_x, max_y, ilog_lu,
     +		az_el, dop_sweep, max_gates, num_bins, 
     +		num_rays, iersm,
     +		imax, jmax, sx, sy, xdis, ydis, rlat, rlon,
     +		 slat, slon, rmx, rdel_z, time, nmosm, itflg,
     +		radiita, bad_val)

	write(6,*)' Finished dop interpolation.' 
	call rvp8_nointerp_convt(idata_type, elmin, elmax,
     +		spw_int, max_x, max_y, ilog_lu,
     +		az_el, spw_sweep, max_gates, num_bins, 
     +		num_rays, iersm,
     +		imax, jmax, sx, sy, xdis, ydis, rlat, rlon,
     +		 slat, slon, rmx, rdel_z, time, nmosm, itflg,
     +		radiita, bad_val)

	write(6,*)' Finished spr interpolation.' 

C display
C display interpolated array/
	display_label = 'dBZ'
	zmin = -10.00
	zmax = 60.0
	idata_type = 1 ! dbz
        call show_iz(ixl, iyb, dBZ_int, max_x, max_y,imax,jmax,
     +		zmin, zmax, idata_type, too_noisy, ambiguous,
     +		dbz_window, display_label)
C Caption 
	icap_col = 16 ! color for caption
	radnm = 'GIV TDR'
	radar_id = ' N49'
	project = 'Test Flight'
	call cap_solo(ixl + imax+5, iyb + jmax, imax,jmax,
     +		radnm,radar_id, project,
     +		avg_roll, time, month, iday,iyear,sx,sy,icap_col,
     +		idata_type, dbz_window)
C
	call color_bar(idata_type, ixl+imax+4, iyb, zmin, zmax, 
     +		nyq_vel, dbz_window)

C Doppler indow
	display_label = 'Doppler'
	zmin = -vel_nyq
	zmax = vel_nyq
	idata_type = 2 ! not dbz
        call show_iz(ixl, iyb, dop_int, max_x, max_y,imax,jmax,
     +		zmin, zmax, idata_type, too_noisy, ambiguous,
     +		dop_window, display_label)
C Caption 
	icap_col = 16 ! color for caption
	radnm = 'GIV TDR'
	radar_id = ' N49'
	project = 'Test Flight'
	call cap_solo(ixl + imax+5, iyb + jmax, imax,jmax,
     +		radnm,radar_id, project,
     +		avg_roll, time, month, iday,iyear,sx,sy,icap_col,
     +		idata_type, dop_window)
C
	call color_bar(idata_type, ixl+imax+4, iyb, zmin, zmax, 
     +		nyq_vel, dop_window)
C Spectral Width window
	display_label = 'Spectral Width'
	zmin = 0.0
	zmax = 12.0
	idata_type = 2 ! not dbz
        call show_iz(ixl, iyb, spw_int, max_x, max_y,imax,jmax,
     +		zmin, zmax, idata_type, too_noisy, ambiguous,
     +		spw_window, display_label)
C Caption 
	icap_col = 16 ! color for caption
	radnm = 'GIV TDR'
	radar_id = ' N49'
	project = 'Test Flight'
	call cap_solo(ixl + imax+5, iyb + jmax, imax,jmax,
     +		radnm,radar_id, project,
     +		avg_roll, time, month, iday,iyear,sx,sy,icap_col,
     +		idata_type, spw_window)
C
	call color_bar(idata_type, ixl+imax+4, iyb, zmin, zmax, 
     +		nyq_vel, spw_window)

c
	if( batch_flag .ne. 'b' ) then
		write(6, *)' Pausing for you to grk image '
		read( 5,'(a1)')option
		if(option.eq.'q') then
		   go to 1000 
		else if(option.eq.'t')then
	   write(tif_file_name ,222)iyear,month,iday,ih,im,is
222	   format("rvp8_",i4.4,i2.2,i2.2,"_",3(i2.2),"_dBZ.tif" )
	   call snapshot(window_label(1), tif_file_name)
	  tif_file_name(22:24) = "dop"
	   call snapshot(window_label(2), tif_file_name)
	   tif_file_name(22:24) = "spw"
	   call snapshot(window_label(3), tif_file_name)

		end if
	else ! may need to save tiff in batch
C also get tiffimages

	 if(make_tif .eq. 1) then ! *******************************
	   write(tif_file_name ,222)iyear,month,iday,ih,im,is
	   call snapshot(window_label(1), tif_file_name)
	  tif_file_name(22:24) = "dop"
	   call snapshot(window_label(2), tif_file_name)
	   tif_file_name(22:24) = "spw"
	   call snapshot(window_label(3), tif_file_name)
	 end if ! *************************************

	end if
C
C	
	if(isweep .lt. num_sweeps)then
C there are more sweeps left in this file
	  go to 4321
	else
C go get another sweep file
	  go to 10 ! get another sweep
	end if
900	write(6,*)"err reading list"
	go to 1000
990	write(6,*)"err oprning list"
	go to 1000
C
1000	write(6,*)"end"


	end
C  ===========================================================================
C  ---------------------------------
	subroutine show_iz(ixl, iyb, iz, max_x, max_y,imax,jmax,
     +        zmin,zmax, data_type, too_noisy, ambiguous,
     +		im_struct, display_label)
C convert dBZ or Doppler to 0-15, show on X window
	integer*2 iz(max_x, max_y)
	integer data_type
	integer*4 im_struct(86)
C
	character*32 display_label
	parameter( iras_max = 640, jras_max = 480)
	integer*4 raster(iras_max, jras_max)
C
	do j = 1, jras_max
		do i = 1, iras_max
			raster(i, j) = 0
		end do
	end do
C
	if( data_type .eq. 1) then ! dBZ
	  zscale = 12.0 / (zmax - zmin) ! for colors 2-14
	  do j = 1, jmax
	   do i = 1, imax
	    ival = iz(i, j)
	    if( ival .eq. -9999)then ! missing, set to 0
		icol = 0
	    else
		val = ival * 0.1
		if(val .lt. zmin)then
			icol = 1
		else if(val .gt. zmax)then
			icol = 15
		else
			icol = 2 + (val-zmin) * zscale
		end if
	    end if
	    raster(ixl + i, iyb + j)  = icol
	   end do
	  end do
	else if( data_type .eq. 2) then
		zscale = 12.0 / (zmax - zmin) ! for colors 2-14
		do j = 1, jmax
		    do i = 1, imax
		    	ival = iz(i, j)
			val = ival * 0.1
C in main too_noisy = -200.0, bad-val = -999.9, so this takes care of both:
			if(val .le. too_noisy)then
				icol = 0
C ambiguous = -100.0
			else if(val .le. ambiguous)then
				icol = 1
			else if(val .lt. zmin)then
				icol = 0
			else if(val .gt. zmax)then
				icol = 15
			else
				icol = 2 + (val-zmin) * zscale
			end if
			raster(ixl + i, iyb + j)  = icol
		    end do
	  end do
	end if
        call rasx_display_image(iras_max, raster, im_struct,
     +		display_label)
C and outline area:
	call x_tvline(ixl, iyb, ixl + imax, iyb, 15,im_struct)
	call x_tvline(ixl+imax, iyb, ixl + imax, iyb+jmax, 15,im_struct)
	call x_tvline(ixl, iyb+jmax, ixl + imax, iyb+jmax, 15,im_struct)
	call x_tvline(ixl, iyb, ixl, iyb + jmax, 15,im_struct)
	return
	end
C --------------------------------------
      subroutine cap_solo(ixl, iyt, imax, jmax, rad_name, radar_id,
     +	project, avg_roll, time, mon, day, yr, sx, sy, icol,
     +	data_type, im_struct)
C Text captions 
      parameter(ispac = 20)
	integer*4 im_struct(86)
      integer mon,day,yr
	integer data_type
      character string*21,rad_name*8, project*20,radar_id*4
      character*3 chmon(12)
      save chmon
      data chmon/'Jan','Feb','Mar','Apr','May','Jun','Jul', 
     +        'Aug','Sep','Oct','Nov','Dec'/
      ifont = 1 
       call x_tvtype(ixl,iyt-6*ispac,project,20,ifont,icol,im_struct) 
c date: 
	if( ( mon.ge. 1) .and. ( mon .le. 12 ) )then
	        string(1:3)=chmon(mon)
        	write(string(4:7),'(". ",i2)')day 
		if(yr.lt.1900) yr = yr + 1900
	        write(string(8:13),'(", ",i4)')yr 
	        call x_tvtype(ixl,iyt-ispac,string,13,ifont,
     +			icol,im_struct) 
Cout		call ctme(time,ih,im,is)

		ih = time / 3600.0
		im = (time - ih*3600.0)/60.0
		is = time - ih * 3600.0 - im * 60.0

		string(1:12)='nn:nn:nn UTC'
		write(string(1:8),'(i2,":",i2.2,":",i2.2)')ih,im,is
	        call x_tvtype(ixl,iyt-2*ispac,string,12,ifont,
     +			icol,im_struct) 
	end if
C domain:
	iwide=imax*sx 
	itall=jmax*sy 
	write(string(1:3),'(i3)')iwide 
	write(string(7:9),'(i3)')itall
	string(4:6)=' x ' 
	string(10:12)=' km' 
	call x_tvtype(ixl,iyt-4*ispac,string,12,ifont,icol,im_struct)
C Foll angle
	string(1:18) = 'Roll snn.n deg avg'
	write(string(6:10),'(f5.1)')avg_roll
        call x_tvtype(ixl,iyt-3*ispac, string, 17, ifont,
     +		icol,im_struct)
c Site ID
	call x_tvtype(ixl,iyt-5*ispac,rad_name,8,ifont,icol,im_struct) 
c where it is:
C	call x_tvtype(ixl,iyt-5*ispac,radnam,10,ifont,icol,im_struct) 
C
	return
	end
C -----
	subroutine color_bar(itype, ixl, iyb, zmin, zmax, nyq_vel,
     +		im_struct)
	character string*21, chdb*8
	real zmin, zmax, nyq_vel
	integer*4 im_struct(86)
C
	ixbl = ixl
	iybb = iyb
	iht = 20
	ixbr = ixl + iht
	icol = 16
	if( itype .eq. 1 ) then 
C Dbz:
	iybb = iyb - 2*iht
        scaling = ( zmax - zmin )/12.0
         do i = 2, 14 
          call x_tvfrec(ixbl+1, (iybb+i*iht)+1, ixbr-1,
     +		(iybb+(i+1)*iht), i, im_struct)
	  idbz1=((i-2)*scaling)+zmin ! low dbz 
	  idbz2=((i-1)*scaling)+zmin ! high dbz 
	  idbzm = idbz1 + (idbz2-idbz1)*0.5
	  write(chdb(1:2),'(i2)')idbzm
	  if((i .eq.2).or.(i.eq.14)) then
		write(chdb(3:6),'(a4)')' dBZ'
		call x_tvtype(ixbr+1,(iybb+i*iht)+2,chdb,6,1,
     +			icol, im_struct)
	  else
		call x_tvtype(ixbr+1,(iybb+i*iht)+2,chdb,2,1,
     +			icol, im_struct)
	  end if
         end do
C
	else if( itype .ge. 2) then
C Doppler
	iybb = iyb - iht
        scaling = ( zmax - zmin )/12.0
	 i = 1
	 call x_tvfrec(ixbl+1, (iybb+i*iht)+1, ixbr-1,
     +		(iybb+(i+1)*iht), i, im_struct)
	 string = 'Range Ambiguous'
	 call x_tvtype(ixbr+1, (iybb+i*iht)+2, string, 15, 1,
     +		icol, im_struct)
	 do i = 2, 14 
	  call x_tvfrec(ixbl+1, (iybb+i*iht)+1, ixbr-1,
     +		(iybb+(i+1)*iht), i, im_struct)
	  idbz1=((i-2)*scaling)+zmin ! low vel 
	  idbz2=((i-1)*scaling)+zmin ! high vel 
	  idbzm = idbz1 + (idbz2-idbz1)*0.5
	  write(chdb(1:3),'(i3)')idbzm
	  if( (i .eq.2).or.(i.eq.14) ) then
	    write(chdb(4:7),'(a4)')' m/s'
	    call x_tvtype(ixbr+1, (iybb+i*iht)+2, chdb, 7, 1,
     +		icol, im_struct)
	  else
	  call x_tvtype(ixbr+1, (iybb+i*iht)+2, chdb, 3, 1,
     +		icol, im_struct)
	  end if
	 end do
	 string = 'Nyquist vel nn.nn m/s'
	 write(string(13:17),'(f5.2)')nyq_vel
         call x_tvtype(ixbl-50,iybb-20,string,21,1,icol,
     +		im_struct) 
C
	end if
	return
	end 

