C accum dbz stats from series of rvp8
C sweep files. Keep seperate stats for
C fore and aft antennae.
D
	program dbz_stats
	implicit none
c /read in a radar tape file and write out sweeos in the
c SIGMET/Vaisala IRIS Raw data format. to simlate sweeps
C written out by the RVP8. Oh how I did not want to
C write this code.... started 9 Dec 2008. Peter Dodge,
C radar data p;umber, HRD 
C Iris data structures
	integer max_rays, max_gates
	parameter(max_rays = 500, max_gates = 2048)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...

	integer*4 swapped, read_stuff
	character*80 sweep_fn, temp_fn
	character*80 list_fn
	integer list_lu
C swp_lu is actually a pointer to a file descriptor. On thor
C pointersare 4 byte but on helios, a 64 bit machine, thr pointers are 8 bytes
Cout	integer*4 swp_lu
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
	integer*4 num_fields
	integer*4 io_error

	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
					
	type ( struct_hdr ) str_hdr
	type ( product_config ) prod_conf
	type ( product_end ) prod_end
	type ( ingest_configuration) i_config
	type ( task_sched_info ) t_sched
	type ( task_dsp_info ) t_dsp
	type ( task_calib_info ) t_calib
	type ( task_range_info ) t_range
	type ( task_scan_info ) t_scan

	type ( ymds_time ) start_time_str
	type ( ymds_time ) end_time_str
	
	type ( task_misc_info ) t_misc
	type ( task_end_info ) t_end

	type ( task_rhi_scan_info ) t_rhi
	type ( task_ppi_scan_info ) t_ppi
	
	type ( ingest_data_hdr ) idh(MAX_FIELDS) ! /* should be more general! */
	type ( raw_prod_bhdr ) rpbh
	type ( ray_hdr ) rh(max_rays)
  	type ( TDR_hdr ) air_hdr(max_rays)

C and here are the arrays for the pther data types:
	real*4 dbz(max_gates)
	real*4 dop(max_gates)
	real*4 wid(max_gates)
	real*4 vel_nyq
C  and 3 arrays i can use for displaying sweeps
	real dbz_sweep(max_gates, max_rays)
	real dop_sweep(max_gates, max_rays)
	real spw_sweep(max_gates, max_rays)
	real az_el( 2, max_rays)

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

	character*80 radar_fn
	character*4 time_string
C 
	character*80 dump_fn
c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	include "hrd_radar_common_blocks.f"

	logical french_antenna
	character*1 antenna_type
C
C array of flags to select data
	integer data_sel_flags(3)
C
	integer*4 num_rays_array(1:360)
	integer*4 del_az_dist(5,360)
	integer num_zero_nbrs(360)
	integer num_bins(360)
C
	integer*4 num_sweeps_read
	real perc
C
	integer nav_ang, ipos_max
	integer tot_fat_rays
	real perc_fat_rays, perc_zero_nbrs
	integer iprev, inext
	real del_az
	real tilt_beg, tilt_end
	real az_beg, az_end
	real dbz_min, dbz_max, dop_min, dop_max
	real wid_min, wid_max
	real bad_val, avg_roll
	real bam16_to_deg
	real bam32_to_deg
	integer i, ii, ib
	real wavelength, dbz_max_2
	integer igood_read, isweep
	integer num_sweeps, num_rays
c
	integer*4 fore_dbz_freq(-20:80)
	integer*4 aft_dbz_freq(-20:80)
	integer idbz
	integer*4 fore_total, aft_total
	real fore_perc, aft_perc
	real cum_perc_fore, cum_perc_aft
C
cout	integer ih, im,is, iyear, month, iday

C
	num_sweeps_read = 0
	do i = -20, 80
	   fore_dbz_freq(i) = 0
	   aft_dbz_freq(i) = 0
	end do
	fore_total = 0
	aft_total = 0
C
	do i = 1, 360
	  num_rays_array(i) = 0
	  num_zero_nbrs(i) = 0
	  do ii = 1, 5
		del_az_dist(ii,i) = 0
	  end do
	end do
C
	bad_val = -999.0
	igood_read = 1 ! for testing io_error in get tdr ray
C
c default data types
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_WIDTH2
C
	read_stuff = 0 ! set to  1 to get massive dump of info
	call getarg(1, list_fn)
	if(list_fn .eq. ' ')then
	  write(6,*)' IRIS radar  files list: '
	  read(5,'(a)') list_fn
	end if
	list_lu = 13
	open(list_lu,file=list_fn,form='formatted',status='old')

c
10	read(list_lu,'(a)',end=343) sweep_fn

	call open_iris_file(swp_lu, sweep_fn, iostat)

	if(iostat .ne. 1) then
		stop ' Coild not open file. adios '
	else
		write(6,*) "Opened sweep file", sweep_fn
	end if

	call check_byte_swapping(swp_lu, swapped)
c
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
	call read_product_hdr(6, prod_conf, prod_end)

	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_sched, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	tot_read = 2 * BLK_LENGTH
C

	call read_task_hdr(6, t_sched, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
	wavelength= t_misc%wavelength * 0.0001
	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )
	write(6, *)"Myquist velocity ",vel_nyq," m/s"
	if(t_dsp%prf_mode .eq. 0) then
	   write(6,*)" Single PRF mode", vel_nyq
	else
	   write(6,*)" Dual PRF mode ",t_dsp%prf_mode, vel_nyq
	end if
C
	num_sweeps_read = num_sweeps_read + 1
C
	dump_fn = ' '
	write(dump_fn, 777)iyear,month, iday, ih,im,is
777	format( i4,5(i2.2),'az_dump.txt')

cdout	open(33,file=dump_fn,form='formatted')
cdout	write(33,778)sweep_fn
778	format("sweep file: ",a)
C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.
	num_sweeps = t_scan%num_sweeps
	num_fields = i_config%num_assoc_files

	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C 
cdput	write(33,*)" ====================================="
cdout	write(33,*)"ray, num bins,",
cdout     +		" msec_since_sweep_start,",
cdout     +		" az_beg, az_end, del_az, dbz_max",
cdout     +		"dbz_max_2,ipos_max,",
cdout     +		" irs_age, gps_age"

cdout	write(33, *)" ===================================="
C Dump some Ingest configuration stuff
	   avg_roll = 0.0
	call flush(6)

C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
C
	  num_rays = idh(num_fields)%expected_num_rays
C dump ingest data header variavles


C finally read the rays and expand the data, including the extended headers
	  do i = 1, num_rays
	write( 6, '("ray # ", i3,1x, 58("=") )'), i
	call flush(6)

	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dbz, dop, wid, 
     *		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)
	   if( io_error .ne. igood_read) then
		go to 333 ! break out
	   end if
C Archaeology... which pad word now holds removed velocity?
c
	   call  read_TDR_hdr(0, air_hdr(i) )

	   avg_roll = avg_roll + roll
	   num_bins(i) = rh(i)%num_bins_in_ray
	   if(num_bins(i) .gt. 0) then
		num_rays_array(i) = num_rays_array(i) + 1
	   end if
c load sweep arrays for later display
	   do ib = 1, num_bins(i)
		dbz_sweep( ib, i) = dbz(ib)
		dop_sweep(ib, i) = dop(ib)
		spw_sweep( ib, i) = wid( ib )
	   end do
C note taht i swap az and el, so first angle is the rotation, 2nd is the tilt
	   az_el(1, i) = bam16_TO_deg(rh(i)%el_beg )
	   az_el(2, i) =bam16_TO_deg( rh(i)%az_beg )
	write(6,787)i,az_el(1,i), az_el(2,i)
787	format(1x,i3,1x,f6.1,1x,f5.1)
C based on tail tilr angle,
C add to dbz freq accumulation
	if(az_el(2, i).lt.0.0) then
	   do ib = 1, num_bins(i)
		if(dbz(ib) .gt. bad_val) then
		   idbz = nint(dbz(ib))
		   if(idbz .le. -20) then
			aft_dbz_freq(-20) = aft_dbz_freq(-20) + 1
		   else if(idbz .gt. 80) then
			aft_dbz_freq(80) = aft_dbz_freq(80) + 1
		   else
			aft_dbz_freq(idbz) = aft_dbz_freq(idbz) + 1
		   end if
		   aft_total = aft_total + 1
		end if
	   end do
C else forward pointinf beam
	 else
	   do ib = 1, num_bins(i)
		if(dbz(ib) .gt. bad_val) then
		   idbz = nint(dbz(ib))
		   if(idbz .le. -20) then
			fore_dbz_freq(-20) = fore_dbz_freq(-20) + 1
		   else if(idbz .gt. 80) then
			fore_dbz_freq(80) = fore_dbz_freq(80) + 1
		   else
			fore_dbz_freq(idbz) = fore_dbz_freq(idbz) + 1
		   end if
		   fore_total = fore_total + 1
		end if
	   end do
	 end if
C 
	   call get_ray_min_max(dbz, num_bins(i), bad_val,
     +		dbz_min, dbz_max)
	   call get_ray_min_max(dop, num_bins(i), bad_val,
     +		dop_min, dop_max)
	   call get_ray_min_max(wid, num_bins(i), bad_val,
     +		wid_min, wid_max)
C those calls find the min and max liiking all aling the
C the ray, including any crap at the ends. so i will get
C anothe  dbz max, just liiking within the unavdi rannge

	dbz_max_2 = -99.9
	ipos_max = -1
C i exclude all the crap within 2.5 km od
C the aircraft...a guess and here i assume 100 m bins
C NO I have ot exckude the whole ring that extends to the ground,,,
C if i want to use this test to find the rays with
C shitty angles. 
	do ii = 180, min(500, num_bins(i)),1
	  if(dBZ(ii).gt.bad_val)then
	    if(dbz(ii).gt.dbz_max_2)then
		dbz_max_2 = dbz(ii)
		ipos_max = ii
	    end if
	  end if
	end do

C some stuff to look at az angles
	   az_beg = bam16_TO_deg(rh(i)%el_beg )
	   az_end = bam16_TO_deg(rh(i)%el_end )
	   tilt_beg = bam16_TO_deg(rh(i)%az_beg )
	   tilt_end = bam16_TO_deg(rh(i)%az_end )

		del_az = az_end - az_beg
C
	del_az = abs(del_az)
	if(del_az.gt.340)del_az = 360.0-del_az
	if(num_bins(i) .gt. 0) then
C only count non zero rays
	 if(del_az .le. 1.0)then
	  del_az_dist(1,i) = del_az_dist(1,i) + 1
	 else if(del_az .le. 2.0)then
	  del_az_dist(2,i) = del_az_dist(2,i) + 1
	 else if(del_az .le. 3.0)then
	  del_az_dist(3,i) = del_az_dist(3,i) + 1
	 else if(del_az .le. 4.0)then
	  del_az_dist(4,i) = del_az_dist(4,i) + 1
	 else 
	  del_az_dist(5,i) = del_az_dist(5,i) + 1
	 end if
	end if
	if(del_az .gt. 1.0) then
C check for neighboring empty rays
	  if(i.eq.1)then
	    iprev=360
	    inext = 2
	  else if(i.eq.360)then
	     iprev = 359
	     inext = 1
	  else
	      iprev = i-1
	      inext = i+1
	  end if
	  if((num_bins(iprev).eq.0) .or. (num_bins(inext).eq.0))then
	    num_zero_nbrs(i)=num_zero_nbrs(i)+1
	  end if
	end if
cdout	if(tilt_end .ne. tilt_end) then
cdout	  write(33,*)'WTF? tilt changed',tilt_beg, tilt_end
cdout	end if
cdout	if( num_bins .gt. 0 ) then
cdout	write(33,636)i, num_bins,
cdout     +		air_hdr(i)%time_since_sweep_start,
cdput     +		az_beg, az_end, del_az,dbz_max,
cdout     +		dbz_max_2, ipos_max,
cdout     +		air_hdr(i)%irs_age, air_hdr(i)%gps_age
cdout	else
cdout	write(33,636)-i, num_bins,
cdout     +		air_hdr(i)%time_since_sweep_start,
cdout     +		az_beg, az_end, del_az, dbz_max,
cdout     +		dbz_max_2,ipos_max,
cdout     +		air_hdr(i)%irs_age, air_hdr(i)%gps_age
cdout	end if
636	format(i4,1x,i4,1x,i5,2(1x,f6.1),1x,f7.2,2(1x,f5.1),1x,i4,
     +    2(1x,i6))

	  end do ! rays loop

	   avg_roll = avg_roll / num_rays
	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


333	call close_iris_file(swp_lu)
cdout	call close(33)
C go get another file
	go to 10
C
343	open(34,file='angle_stats.txt',form='formatted')
	write(34,*)list_fn
	write(34,*)num_sweeps_read,' sweeps read'
	write(34,*)'ray num,nav ang, rays, percentage'
	do i = 1, 360
	   nav_ang = 450 - i
	   if(nav_ang .gt. 360)then
		nav_ang = nav_ang - 360
	   end if
	   perc = (100.0*num_rays_array(i)) / num_sweeps_read
	   tot_fat_rays = 0
	   do ii = 2, 5
	     tot_fat_rays = tot_fat_rays + del_az_dist(ii,i)
	   end do
	   if(tot_fat_rays .gt. 0.0) then
	     perc_fat_rays = tot_fat_rays/(del_az_dist(1,i)+tot_fat_rays)
	     perc_fat_rays = 100.0 * perc_fat_rays
	     perc_zero_nbrs = 100.0 * num_zero_nbrs(i) / tot_fat_rays
	   else
	     perc_fat_rays = 0.0
	     perc_zero_nbrs = 0.0
	   end if
	   write(34,3343)i,nav_ang,num_rays_array(i), perc,
     +		(del_az_dist(ii,i),ii=1,5),perc_fat_rays, 
     +		num_zero_nbrs(i),perc_zero_nbrs
3343	   format(i3,1x,'(',i3,')',1x,i4,1x,f6.2,5(1x,i4),1x,f5.1,
     + 1x,i4,1x,f5.1)
	end do
	close(34)
C writw dba frea
	open(35,file='dbz_freq.txt',form='formatted')
	write(35,*)'i,fore,perx,aft.pers'
	cum_perc_aft = 0.0
	cum_perc_fore = 0.0
	do i = -20, 80
	  aft_perc = 100.0*aft_dbz_freq(i)/aft_total
	  fore_perc = 100.0*fore_dbz_freq(i)/fore_total
	  cum_perc_aft = cum_perc_aft + aft_perc
	  cum_perc_fore = cum_perc_fore + fore_perc
	  write(35,789)i, fore_dbz_freq(i), fore_perc,
     +	    aft_dbz_freq(i), aft_perc, 
     +	    cum_perc_fore, cum_perc_aft
789	format(1x,i3,1x,2(i8,1x,f4.1,1x),2(f4.1,1x))
	end do
C Now do again, ignoring lower dVZ
	cum_perc_aft = 0.0
	cum_perc_fore = 0.0
	fore_total = 0
	aft_total = 0
	do i = 20, 60
	  fore_total = fore_total + fore_dbz_freq(i)
	  aft_total = aft_total + aft_dbz_freq(i)
	end do
	write(35,*)' ================= '
	write(35,*)'only looking at dbz 20-60:'
	write(35,*)'dbz,fore, fore %, aft, aft %, cum fore,aft'
	do i = 20, 60
	  aft_perc = 100.0*aft_dbz_freq(i)/aft_total
	  fore_perc = 100.0*fore_dbz_freq(i)/fore_total
	  cum_perc_aft = cum_perc_aft + aft_perc
	  cum_perc_fore = cum_perc_fore + fore_perc
	  write(35,789)i, fore_dbz_freq(i), fore_perc,
     +	    aft_dbz_freq(i), aft_perc, 
     +	    cum_perc_fore, cum_perc_aft
	end do

C
	close(35)
C
	End
