C Code written by Nancy Griffin to find end of sweep for French Antenna
C "Following is the short routine to handle end of sweep for the French
C Antenna.  It is used in conjunction with radartaperead.f."
      subroutine eos_french(ioldsweep,oldtimeswp,nullray,nix)
C
      COMMON /TAPEHEADER/ nbytesheader,ntape,nversion,ihheader,imheader,
     +                    isheader,ine,ndrive,naircraft,flightid,stmname
     +                    ,nsamplelf,nsampleta,refslopelf,refslopeta,
     +                    refnoisethreslf,refnoisethresta,sqilf,sqita,
     +                    widththreslf,widththresta,caliblf,calibta,
     +                    modedatalf,modedatata,noisetmlf,noisetmta,
     +                    rpmlf,rpmta,gtlnlf,ivrangelf,ivrangeta,
     +                    gtlnta(3),rdellf,rdelta,rdelcorlf,rdelcorta,
     +                    nbinlf,nbinta,nbins,rmaxlf,rmaxta,
     +                    radiita(512),radiilf(512),iheader(1024)
      COMMON /RAYHEADER / nbytesdata,nlfsweep,ntasweep,numrecord,
     +                    irecflag,idradar,nbytesray,icode,idsp,mdata,
     +                    iyear,month,iday,iraycode,time,ih,im,
     +                    is,is100,rlat,rlon,ra,gse,gsn,gs,vgs,
     +                    ucom,vcom,wd,ws,vws,ircu,
     +                    elev,azm,pitch,roll,drift,heading,
     +                    dbzbuffer(512),velbuffer(512),widthbuffer(512)
      INTEGER*2 IHEADER
      CHARACTER FLIGHTID*8,STMNAME*16 
c
c ioldsweep = the previous sweep number; set at calling routine.(input)
c oldtimeswp = the sweep number at the start of the sweep.
c nullray = flag that determines if the antenna has been switched.
c           The elevation goes to zero at the switch.
c nix = 7777 end-of-swwep (output)
c          0 same sweep
c
      if (rpmta.gt.0.0) rateswp=60.0/rpmta
      if (ifix(elev) .eq. 0) then
         oldtimeswp=time
         nix=0
         if (nullray.eq.0)nix=7777
         nullray=nullray + 1
      else if (abs(ioldsweep-ntasweep).ge.1 .and.
     +         abs(time-oldtimeswp) .lt. rateswp) then
         nix=0
      else if (abs(ioldsweep-ntasweep).ge.1) then
         oldtimeswp=time
         nix=7777
      endif
      if (ifix(elev) .ne. 0) nullray=0
      return
      end

