	subroutine read_TDR_hdr(lu, air_hdr)
c load GIV  radar exended headr with info from 
c radar tape header in common blicks
C fragments for reading HRD tape or file
C mod 14 July 2011 to use flags in a new
C common block to decide whick vlues
C shoild be assigned to nav, etx.
C
C For each flaf,
C	1: use inertial values ( airs )
C	2: use GPS values
C	3: use AAMPS values
C
	common /hidden_hdr_flags/ nav_choice,
     +		alt_choice, attitude_choice, gdspd_choice,
     +		wind_choice
	integer*4 nav_choice,
     +		alt_choice, attitude_choice, gdspd_choice,
     +		wind_choice


C added tis to make latest external header avail to calling
C programs:
	include "TDR_hdr_common.f"
C and this include has all the RVP stuff:
	include "TDR_hdr_f90.h"
	TYPE (TDR_hdr) air_hdr

C
	include "hrd_radar_common_blocks.f"
C
C load angles from 32 bit binary angles
	gps_lat = bam32_TO_deg(air_hdr%gps_lat)   ! /**< GPS latitude (BAM) */
	gps_long = bam32_TO_deg(air_hdr%gps_long)  ! /**< GPS Longitude (BAM) */
	airs_lat = bam32_TO_deg(air_hdr%irs_lat)   ! /**< IRS latitude (BAM) */
	airs_long = bam32_TO_deg(air_hdr%irs_long)  ! /**< IRS Longitude (BAM) */
	aamps_lat = bam32_TO_deg(air_hdr%aamps_lat)   ! /**< AAMPT latitude (BAM) */
	aamps_long = bam32_TO_deg(air_hdr%aamps_long)  ! /**< AAMPT Longitude (BAM) */
	aamps_alt = air_hdr%aamps_alt * 0.01   ! /**< AAMPT Altitude (cm) */


C get angles from 16 bit binary angles
	airs_pitch = bam16_TO_de g(air_hdr%irs_pitch)     ! /**< IRS Pitch (BAM) */
	airs_roll = bam16_TO_deg(air_hdr%irs_roll)      ! /**< IRS Roll (BAM) */
	airs_heading = bam16_TO_deg(air_hdr%irs_heading)   ! /**< IRS Heading (BAM) */
	airs_drift = bam16_TO_deg(air_hdr%irs_drift)     ! /**< IRS Drift (BAM) */
	airs_tru_track = bam16_TO_deg(air_hdr%irs_tru_track) ! /**< IRS True Track (BAM) */
	airs_pitch_r = bam16_TO_deg(air_hdr%irs_pitch_r)   ! /**< IRS Pitch rate (BAM/sec) */
	airs_roll_r = bam16_TO_deg(air_hdr%irs_roll_r)    ! /**< IRS Roll rate (BAM/sec) */
	airs_yaw_r = bam16_TO_deg(air_hdr%irs_yaw_r)     ! /**< IRS Yaw rate (BAM/sec) */
	airs_wind_dir = bam16_TO_deg(air_hdr%irs_wind_dir)  ! /**< IRS Wind direction (BAM) */
	aamps_pitch = bam16_TO_deg(air_hdr%aamps_pitch)     ! /**< AAMPT Pitch (BAM) */
	aamps_roll = bam16_TO_deg(air_hdr%aamps_roll)      ! /**< AAMPT Roll (BAM) */
	aamps_heading = bam16_TO_deg(air_hdr%aamps_heading)   ! /**< AAMPT Heading (BAM) */
	aamps_drift = bam16_TO_deg(air_hdr%aamps_drift)     ! /**< AAMPT Drift (BAM) */
	aamps_track = bam16_TO_deg(air_hdr%aamps_track)     ! /* *< AAMPT Track (BAM) */
C

	time_since_sweep_start = air_hdr%time_since_sweep_start
	cal_sig_level = air_hdr%cal_sig_level
	num_bytes = air_hdr%num_bytes
	icrap_1 = air_hdr%pad_1	
	gps_age = air_hdr%gps_age    ! /**< Time in milliseconds since last GPS Input */
	airs_age = air_hdr%irs_age    ! /**< Time in milliseconds since last IRS Input */
	aamps_age = air_hdr%aamps_age  ! /**< Time in milliseconds since last AAMPS Input */
	gps_alt = air_hdr%gps_alt * 0.01    ! /**< GPS Altitude (?cm?ft?) */
	gps_vel_e = air_hdr%gps_vel_e * 0.01 ! /**< GPS Ground Speed East (cm/second) */
	gps_vel_n = air_hdr%gps_vel_n * 0.01  ! /**< GPS Ground Speed North (cm/second) */
	gps_vel_v = air_hdr%gps_vel_v * 0.01  ! /**< GPS Ground Speed Up (cm/second) */
	airs_vel_e = air_hdr%irs_vel_e * 0.01  ! /**< IRS Ground Speed East (cm/second) */
	airs_vel_n = air_hdr%irs_vel_n * 0.01  ! /**< IRS Ground Speed North (cm/second) */
	airs_vel_v = air_hdr%irs_vel_v * 0.01  ! /**< IRS Ground Speed Up (cm/second) */
	airs_wind_vel = air_hdr%irs_wind_vel * 0.01  ! /**< IRS Wind speed (cm/second) */
	icrap_2 = air_hdr%pad_2
	aamps_ground_vel = air_hdr%aamps_ground_vel * 0.01 
	aamp_ground_vel = air_hdr%aamps_ground_vel  * 0.01! /**< AAMPS Ground Speed East (cm/second) */
	time_stamp = air_hdr%time_stamp ! /**< AAMPS Timestamp in UTC (seconds since the epoch) */
	aamps_vel_v = air_hdr%aamps_vel_v * 0.01  ! /**< AAMPT Ground Speed Up (cm/second) */
	icrap_4	= air_hdr%pad_4  ! /**< AAMPT altitude status ??? */

	aamps_radalt_val = air_hdr%aamps_radalt_val *0.01   ! /**< AAMPT altitude (cm) */
	aamps_wind_vel = air_hdr%aamps_wind_vel *0.01  ! /**< AAMPS Wind Speed East (cm/second) */
	aamps_wind_dir = bam16_TO_deg(air_hdr%aamps_wind_dir)
	icrap_5 = air_hdr%pad_5
	aamps_wind_vel_v = air_hdr%aamps_wind_vel_v * 0.01    ! /**< AAMPS Wind Speed Up (cm/second) */
c load nav etc, into  common block parameters
C note that gere is where one woild decide whick parameters to use.
C use gps for aircraft position
	if(nav_choice .eq. 1) then
	   rlat = airs_lat
	   rlon = airs_long
	else if(nav_choice .eq. 2)then
	   rlat = gps_lat
	   rlon = gps_long
	else if(nav_choice .eq. 3) then
	   rlat = aamps_lat
	   rlon = aamps_long
	else 
		rlat = -999.0
		rlon = -999.0
	end if

	if(alt_choice .eq. 1 )then
		ra = -999.0
	else if(alt_choice .eq. 2) then
	   ra = gps_alt
	else if(alt_choice .eq. 3) then
	    ra = aamps_alt
	else 
		ra = -999.0
	end if

C for the patform and wind velocities, amy gave to use some aamps variables
	if(gdspd_choice .eq. 1) then
	   gse = airs_vel_e
	   gsn = airs_vel_n
	   gs = sqrt( gse**2 + gsn**2)
	   vgs = airs_vel_v
	else if(gdspd_choice .eq. 2) then
	else if (gdspd_choice .eq. 3) then
	else
		gse = -999.0
		gsn = -999.0
		gs = -999.0
		vgs = -999.0
	end if

	if( wind_choice.eq.1) then
	else if(wind_choice .eq. 2) then
	else if(wind_choice .eq. 3) then
	    wd = aamps_wind_dir
c  putwind dir in 0,360 deg range
	   if(wd .lt. 0.0)  wd = wd + 360.0

	   ws = aamps_wind_vel



	else
		wd = 0.0
		ws = 0.0
	         vws = 0.0
	end if
	call wdir2uv( wd, ws,  u, v, -999.0, ier)
	ucom = u
	vcom = v
C use inertial data for attitide angles
	pitch =  airs_pitch
	roll = airs_roll
	drift = airs_drift
	heading = airs_heading

C If lu not zero, them dump  into to that lodical unit
	if( lu .ne. 0) then

	end if
	return
	end 
c =======================================
	subroutine print_TDR_header(lu)
	integer*4 lu
	include "TDR_hdr_common.f"
C
	write(lu,*)'gps lat, long: ',gps_lat,gps_long
	write(lu,*)'gps_alt: ',gps_alt
      	write(lu,*)'gps vel e, n: ',gps_vel_e, gps_vel_n
	write(lu,*)'gps_vel_v: ',gps_vel_v
C Inertial:
	write(lu,*)'airs lat, long: ',airs_lat, airs_long
      	write(lu,*)'airs_pitch: ',airs_pitch
	write(lu,*)'airs_roll: ',airs_roll
      	write(lu,*)'airs_heading: ',airs_heading
	write(lu,*)'airs_drift: ',airs_drift
      	write(lu,*)'airs_tru_track: ',airs_tru_track
      	write(lu,*)'airs_pitch_r: ',airs_pitch_r
      	write(lu,*)'airs_roll_r: ',airs_roll_r
	write(lu,*)'airs_yaw_r: ',airs_yaw_r
      	write(lu,*)'airs_vel_e: ',airs_vel_e
	write(lu,*)'airs_vel_n: ',airs_vel_n
      	write(lu,*)'airs_vel_v: ',airs_vel_v
      	write(lu,*)'airs_wind_dir: ',airs_wind_dir
      	write(lu,*)'airs_wind_vel: ',airs_wind_vel
C AAMPS:
	write(lu,*)'aamps lat, long: ',aamps_lat, aamps_long
      	write(lu,*)'aamps_alt: ',aamps_alt
      	write(lu,*)'aamps_pitch: ',aamps_pitch
	write(lu,*)'aamps_roll: ',aamps_roll
      	write(lu,*)'aamps_heading: ',aamps_heading
	write(lu,*)'aamps_drift: ',aamps_drift
      	write(lu,*)'aamps_track: ',aamps_track
	write(lu,*)'aamp_ground_vel: ',aamp_ground_vel
      	write(lu,*)'aamps_radalt_val: ',aamps_radalt_val
      	write(lu,*)'aamps_wind_vel: ',aamps_wind_vel
      	write(lu,*)'aamps_wind_dir: ',aamps_wind_dir
      	write(lu,*)'aamps_wind_vel_v: ',aamps_wind_vel_v
      	write(lu,*)'aamps_vel_v: ',aamps_vel_v

	write(lu,*)'time stamp: ',time_stamp
	write(lu,*)' time_since_sweep_start: ',time_since_sweep_start
	write(lu,*)'cal_sig_level: ',cal_sig_level
	write(lu,*)'gps_age: ', gps_age
      	write(lu,*)'airs_age: ',airs_age
      	write(lu,*)'aamps_age: ',aamps_age

	return
	end

