C plot_rays_dump.f
C read file produced by rays_dump and plot
C az and time versus ray number, to better visualize
C the bad angle problem...
C
	program plot_rays_dump
C
	parameter(max_rays = 720)
	integer ray_num(max_rays)
	integer num_bins(max_rays)
	integer time_since_sweep_start(max_rays)
	real az_beg(max_rays), az_end(max_rays), del_az(max_rays)
	real dbz_max(max_rays)
	real dbz_max_2(max_rays)
	integer ipos_max(max_rays)
	
	integer i
	real angle
	character*80 fn
	character*90  fn_string
C stuff for plotting:
	integer plotter, plot_type

	integer iht, iwid
C
	real depth, width, dist_max
	real x, y, xp, yp, xl, xr, yb, yt, ymid
	real x_sc, dop_sc, dbz_sc, spw_sc
	real window( 4 ) ! clipping window
	integer curve, scatter
	character cstr*100
	integer*2 string(50)
	logical pen_down
	integer thick_line, thin_line, medium_line
C
	thin_line = 1
	medium_line = 2
	thick_line = 3

	curve = 1
	scatter = 2

C
	call getarg(1, fn)
	if(fn .eq. ' ')then
	  write(6,*)' Enter file: '
	  read(5,'(a)') fn
	end if
 	open(33,file=fn,form='formatted',status='old')

cout	write(33,778)sweep_fn
cout 778	format("sweep file: ",a)
	read(33,'(a)')fn_string
C
cout	write(33,*)"ray, secs_from_start,",
cout     +		" msec_since_sweep_start,",
cout     +		" az_beg, az_end, del_az"
	do i = 1, 5
	   read(33,*)
	end do
C
	t_beg = 32766
	t_end = -t_beg
	iray_start = 0
	iray_end = 0
C
	do i = 1, max_rays

	  read(33,636,end=100,err=100)ray_num(i), num_bins(i),
     +		time_since_sweep_start(i),
     +		az_beg(i), az_end(i), del_az(i), dbz_max(i),
     +		dbz_max_2(i),ipos_max(i)

636	format(i4,1x,i4, 1x, i5,2(1x,f6.1),1x,f7.2,2(1x,f5.1),1x,i4)
	  num_rays = i
C note bef and end ray times, ray numbers
	  if(time_since_sweep_start(i) .lt. t_beg) then
		t_beg = time_since_sweep_start(i)
		iray_start = ray_num(i)
	  end if
	  if(time_since_sweep_start(i) .gt. t_end) then
		t_end = time_since_sweep_start(i)
		iray_end = ray_num(i)
	  end if
	end do
100	close(33)
C
	write(6,*)'first ray: ',iray_start, t_beg,az_beg(iray_start),
     +	  az_end(iray_start)
	write(6,*)'last ray: ',iray_end, t_end, az_beg(iray_end),
     +	  az_end(iray_end)
C
	width = 7.0
	depth = 4.0
c
C Initialize plotter
	csiz = 0.1
	tsiz = csiz * 0.5
	xl = 7.0 * csiz
	yb = 7.0 * csiz
	xr = xl +  width
	yt = yb + depth
	yc = yb + depth * 0.5
	ymid = yb + depth * 0.5
	window(1) = xl
	window(2) = yb
	window(3) = xr
	window(4) = yt
C initialize plot for X-window
	plotter = 1
	ires=400
	iwid= (width + 2.0 * xl) * 10 
	iht = (depth + 2.0 * yb) * 10 
	ibkgd_type = 2 ! black background
	call initl(plotter,ires,iwid,iht,ibkgd_type,im,im) 
C
	ipst_file = 1
C
	if( ipst_file .gt. 0) then	! postscript output also
		iwid= (width + 2.0 * xl) * 10 
		iht = (depth + 2.0 * yb) * 10 
		ipst_fntsiz = 10
		call initl(-plotter,ires,iwid,iht,ipst_file,
     +			ipst_fntsiz, im) 
	endif 
	call plot(0.0, 0.0, -3) ! sets origin
C box, axis labels, plot label
	call plot(xl, yb, 3)
	call plot(xl, yt, 2)
	call plot(xr, yt, 2)
	call plot(xr, yb, 2)
	call plot(xl, yb, 2)
C
	call plot(xl, yc, 3)
	call plot(xr, yc, 2)
C now plot, az on the verticla axiz,
C time since sweep start on horizontal aciz
c ASSUME 10RPM, SO 2000 MSEC PER SWEEP FILE
	time_max = 6000.0
	az_max = 360.0
	z_min = -12.0
	z_max = 65.0
	az_sc = 0.5*depth / 180.0
	z_sc = depth / (z_max - z_min)
	x_sc = width / time_max
C label
	read(fn_string,'(45a2)')(string(i),i=1,45)
	call symbl(xl,yt+csiz, csiz, string,0.0, 90)
C axes
	do i = 100, 5900, 100
	  x = xl + i * x_sc
	  call plot(x, yb, 3)
	  call plot(x, yb + tsiz,2)
	 end do
	do i = 0, 6000, 1000
	  x = xl + i * x_sc
	  call plot(x, yb, 3)
	  call plot(x, yb - csiz, 2)
	  ival = i * 0.001
	  write(cstr(1:1),'(i1)')ival
	  read(cstr(1:1),'(a2)')string(1)
	  call symbl(x,yb-1.5*csiz,csiz, string,0.0,1)

	end do
C y axes
C az scale on the left
	do i = -175, 175, 5
	   y = yc + i * az_sc
	   call plot(xl, y, 3)
	   call plot(xl + tsiz, y, 2)
	end do
	do i = -180, 180, 45
	   y = yc + i * az_sc
	   call plot(xl, y, 3)
	   call plot(xl+csiz, y, 2)
	   write(cstr(1:4),'(i4)')i
	   read(cstr(1:4),'(2a2)')string(1),string(2)
	   call symbl(xl-4.0*csiz,y-0.5*csiz,csiz, string,0.0,4)
	end do
C dbz sd;ae on theright
	do i = -10, 60, 5
	   y = yb + (i-z_min) * z_sc
	   call plot(xr, y, 3)
	   call plot(xr - tsiz, y, 2)
	end do
	do i = -10, 60, 10
	   y = yb + (i-z_min) * z_sc
	   call plot(xr, y, 3)
	   call plot(xr - csiz, y, 2)
	   write(cstr(1:3),'(i3)')i
	   read(cstr(1:4),'(2a2)')string(1),string(2)
	   call symbl(xr+ 0.5*csiz,y-0.5*csiz,csiz, string,0.0,3)
	end do
C
C the plot
	tick = tsiz
	do i = 1, num_rays
	  x = xl + time_since_sweep_start(i) * x_sc
	  angle = az_beg(i)
	  y = yc + angle * az_sc
	  angle = az_end(i)
	  y2 = yc + angle * az_sc
	  call plot(x, y, 3)
	  call plot(x, y2,2)
	end do
C and dbz max
	do i = 1, num_rays
	 if(ipos_max(i).gt. -1) then
	  x = xl + time_since_sweep_start(i) * x_sc
	  y = yb + (dbz_max_2(i)-z_min) * z_sc
	  if((y.ge.yb).and.(y.le.yt)) then
	  call plot(x-tick, y, 3)
	  call plot(x, y+tick,2)
	  call plot(x+tick, y, 2)
	  call plot(x, y-tick,2)
	  call plot(x-tick, y, 2)
	  end if
	 end if
	end do
C close plai
C clear plotter, disp;ay
	call plot( 0.0, 0.0, 998)
C
	pause "pauzink"
C
	end
