C mod if tail_ground_stats.f for RVPE data from
C new GIV tail Doppler radar. 2 Aug 2011
C

	program rvp8_ground_stats
C Read new format tapes and accumulate stats on Tail dBZ and VDop
C for rays below aircraft...
C 	parameter (dmax_ta = 1.0, dmax_lf = 2.0)
	character*36 directory
	integer lu, lu_errors

	include "hrd_radar_common_blocks.f"

	logical found_tail, want_port
 	integer maxpts, badz
	integer taplu, irdwr, tape, outlu, ierr, method
	character*32 namram, namout, yesno*1,string*5
	character*32 time_stamp ! for writing out current time
	logical power_wt, searching
	Character iflid*8, istnm*12
C
	integer ta_dBZ_freq(-329:329)
	integer max_dBZ_freq(-329:329)
	integer vDop_freq(-329:329)
	integer plotter
	integer ta_start_bin, ta_end_bin
	integer idataflag, iatten
C
	do i = -329, 329
		ta_dBZ_freq(i) = 0
		max_dBZ_freq(i) = 0
	end do
	do i = -329, 329
		vDop_freq(i) = 0
	end do
C
	deg2rad = acos(-1.0) / 180.0
	rad2deg = 1.0 / deg2rad
C note giv radar has fat 2.88 deg beam !!
C
	half_beam_ta = 1.4 ! degrees, vertical
	beam_wid = 2.0 * half_beam_ta
cout	xnyq = 12.88
C
C
	kindradar = 2 ! 0 =get both tail and lf, 1= lf, 2 = ta
	PCOR = 0.0
	DCOR = 0.0
	RCOR = 0.0
	AZMCOR = 0.0
	ELCOR = 0.0
	write(6,*)' Want to correct attitude angles?'
	read(5,'(a)')yesno
	if( (yesno.eq.'y') .or. (yesno.eq.'Y') ) then
	    write(6,*)' Enter pitch correction (deg):'
	    read(5,*)pcor
	    write(6,*)' Enter drift correction (deg):'
	    read(5,*)dcor
	    write(6,*)' Enter roll correction (deg):'
	    read(5,*)rcor
	end if
	write(6,*)' Want to correct radar antenna angles?'
	read(5,'(a)')yesno
	if( (yesno.eq.'y') .or. (yesno.eq.'Y') ) then
	    write(6,*)' Enter azimuth correction (deg):'
	    read(5,*)azmcor
	    write(6,*)' Enter tilt correction (deg):'
	    read(5,*)elcor
	end if
	luno = 1
C
	irdwr = 0 	! tape is read only
	iprint = 1	! for error messages
	outlu = 22
	lu2 = 23 ! for nadir file
	ipst_file = lu2 + 1 ! for Postscript, if we want...
	nsweep = 0
C get tape, and  output file
cout	write(6,*)' Enter tape drive # '
cout	read(5,*)taplu
cout	call tapeopen(taplu, irdwr, tape)
c
	lu = 10
	lu_errors = 6
	write(6,*)'enter sweep directry'
	read(5,'(a)')directory
	call open_rvp8_file(directory, lu, lu_errors, ierr)


Cout	CALL RADARTAPEREWIND(tape)
cout	call tapecontrol(tape, 2,1) ! backspace one file

	IHEADERFLAG=0 !DON'T WANT BIG HEADER INFO
	IDATAFLAG = 6   ! DBZ ARRAY (BIT 2= ON), vel array bit1 = on.
C
	write(6,*)' Enter output file name :'
	read(5,'(a32)')namout
	open(unit = outlu, file = namout, form = 'formatted')
	write(outlu,*)' This is file ',namout
	write(6,*)' enter angle to examine (vertical +- this):'
	read(5,*)wedge
	cos_wedge = -cosd(wedge) ! for nadir
C	azbeg = 180 - wedge
C	azend = 180 + wedge
	write(outlu,*)'wedge:',wedge
C	write(6,*)' Write inner and outer dis to check (km):'
C	read(5,*)rad_start, rad_end
C	write(outlu,*)' Searched for ',rad_start,' to ',rad_end,' km.'
	write(6,*)' enter range delay correction (km) for tail: '
	read(5,*)rdelcorta
	write(outlu,*)'rdelcorta:', rdelcorta
	write(outlu,321)pcor,dcor,rcor,azmcor,elcor

321	format(' Corrections. pitch: ',f5.2,' drift: ',
     + f6.2,' roll: ',f5.2,/,14x,'AZ: ',f5.2,' Tilt: ',f5.2)
C
	write(6,*)' enter start time (hhmm) '
	read(5,'(2i2)')ihs,ims
	time_start = 3600.0 * ihs + ims * 60.0
	write(6,*)' enter end time (hhmm) '
	read(5,'(2i2)')ihe,ime
	time_end = 3600.0 * ihe + 60.0 * ime
	write(outlu,*)ihs*100+ims,' to ',ihe*100+ime
C
	num_ta_rays = 0
	ifast_type = 4 ! both
C Space to start time
	iswp1 = -1
	time = -1.0
	do while( time .lt. time_start)
	  call radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,
     +		IDATAFLAG, IERR)

	  call convert_time(time,ih,im,is)
c
	time_prev = time

cout	  CALL RADARTAPEREAD(tape,KINDRADAR,IHEADERFLAG,
cout     +			IDATAFLAG,IERR)
	  if(ierr .lt. 0) then
	   if( ierr .gt. -2 ) then
		write(6,*) ' taperead error ',ierr,' will try next.'
	   else if(ierr .eq. -4) then
		write(6,*)"empty ray"
cout		go to ?? ! get next ray
	   else
		write(6,*)ierr, ' eot.'
		go to 900
	   end if
	  end if
	end do
C write out flight id
cout	call cftime(time_stamp)
	write(outlu,*)flightid, ' Tail ground Stats gen on: ',time_stamp
	nsweeps = 0
C do one sweep, use fact that tail always rotates same direction:
100	call radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,
     +		IDATAFLAG, IERR)

	  call convert_time(time,ih,im,is)
c

cout	call RADARTAPEREAD(tape,KINDRADAR,IHEADERFLAG,
cout     +			IDATAFLAG,IERR)
	if(ierr .lt. 0) then
	   if( ierr .gt. -2 ) then
		write(6,*) ' taperead error ',ierr,' try next.'
		go to 100
	   else if(ierr .eq. -4) then
		write(6,*)"empty ray"
		go to 100 ! get next ray
	   else
		write(6,*)ierr, ' eot.'
		go to 900
	   end if
	else if( time .gt. time_end) then
		write(6,*)' passed end time.'
		go to 900
	end if
	call ANGLECOR(pitch,drift,roll,azm,elev,2,PCOR,DCOR,
     +               RCOR,AZMCOR,ELCOR)
Cout	trk = heading - drift
C azm is rel to up, el is tilt fore or aft
C For horizontal rays:
Cout	   if(  abs(sind(azm)) .gt. cos_wedge ) then
C For vertical rays, use cosine as test because cos(175) = cos(185)
	if(  cosd(azm) .lt. cos_wedge ) then
		num_ta_rays = num_ta_rays + 1
C find ground bin and do on either side
	  call find_ground(deg2rad, beam_wid,
     +		rs_th, rs_m, dBz_max, ibeg, Ng2)
	  if ( (dBz_max .gt. 0.0) .and. (ibeg .gt. 0) .and.
     +		(ibeg + Ng2 .le. 1024) ) then ! --> --> --> --> --> --> --> -->
C
		dbz_peak = -329.0
		do i = ibeg, ibeg + Ng2
		   dbz = dbzbuffer(i)
		   if(dbz .gt. dbz_peak) then
			dbz_peak = dbz
		   end if
		   if( dbz .gt. -329.0) then
		      idbz = nint(dbz)
		      ta_dBZ_freq(idbz) = ta_dBZ_freq(idbz) + 1
		   else
		      ta_dBZ_freq(-329) = ta_dBZ_freq(-329) + 1
		   end if
		   vdop = velbuffer(i)
		   if( vdop .gt. -329.00 ) then ! actually -888.88
			ivdop = nint( vdop )
			vDop_freq(ivdop) = vDop_freq(ivdop) +1
		   else
			vDop_freq(-329) = vDop_freq(-329) +1
		   end if
		end do
		idbz = nint(dbz_peak)
		max_dbz_freq(idbz) = max_dbz_freq(idbz) + 1

	   end if ! <--<--<--<--<--<--<--<--<--<--<--<--<--<--<--<--<--<--
	end if
C
C get another ray
cout	if(ifbrk().ne.0) go to 900
	go to 100
900	ihe = ih	! true end time
	ime = im
	write(6,*)' Adios.'
C 
C finish, close file 
	write(outlu,*)'Num TA rays: ',num_ta_rays
	write(outlu,*)' TA dBZ distribution:'
	write(outlu,710)ta_dBZ_freq(-32)
710	format(2x,i10, ' blank')
	tot = 0
	tot_max = 0
	do i = -329, 329
	   if( ta_dBZ_freq(i) .gt. 0 ) then
		tot = tot + ta_dBZ_freq(i)
	   end if
	   if( max_dBZ_freq(i) .gt. 0 ) then
		tot_max = tot_max + max_dBZ_freq(i)
	   end if
	end do
C
	do i = -329, 329
	   if( ta_dBZ_freq(i) .gt. 0 ) then
		write(outlu,700)i, ta_dBZ_freq(i), 
     +			100.0 * ta_dBZ_freq(i) / tot
700	format(1x,i4,2x,i10, 2(2x, f6.2,' %') )
	   end if
	end do
	write(outlu,*)' Max dBZ freg '

	tot_cum = 0
	do i = -329, 329
	   if( max_dBZ_freq(i) .gt. 0 ) then
		tot_cum = tot_cum + max_dBZ_freq(I)
		write(outlu,700)i, max_dBZ_freq(i), 
     +			100.0 * max_dBZ_freq(i) / tot_max,
     +			100.0 * tot_cum/tot_max
	   end if
	end do
C
	write(outlu,*)' Vr Distribution'
	write(outlu,660)vDop_freq(-129)
660	format(i10, ' blank')
	do i = -320, 320
	   if( vdop_freq(i) .gt. 0) then
		write(outlu, 650)i, vDop_freq(i)
	   end if
650	format(1x,i4,1x,i10)
	end do
	close(outlu)
1000	end
C ----------------------------------
	subroutine find_ground(deg2rad, beam_wid, 
     +		rs_th, rs_m, dBz_max, ibeg, Ng2)
C Find the surface, as in Testud's memo.
	include "hrd_radar_common_blocks.f"

	real lambda
C
	theta = elev * deg2rad ! tilt relative to plane perp to radar axis
	beta = pitch * deg2rad
C In Testud's form, 0 is down, -90 port, 90 starboard:
	phi = (180 - (azm + roll) ) * deg2rad 
	epsilon = beam_wid * deg2rad
C Now get elevation of beam rel to horizontal plane through radar
	sn_lambda = sin(theta) * sin(beta) - 
     *			cos(theta) * cos(beta) * cos(phi)
	lambda = asin(sn_lambda)
C Find theoretical range of surface. - sign because lambda neg
	rs_th = -ra / sn_lambda ! ra in m, radiita in km
C Find # of gates intersecting surface at theoretical range
C This would be formula if dR was constant:
C	Ng = rs_th * epsilon / (dR * tan(lambda) )
C But we may have varying beamwidths, so
Cout	slant_depth = -rs_th * epsilon / tan(lambda) ! slight approximation
Cout	rs_th_in = ( rs_th - slant_depth * 0.5 ) * 0.001
Cout	rs_th_out = ( rs_th + slant_depth * 0.5 ) * 0.001
C mod dec 8 92:
	rs_th_in = -ra / sin(lambda - epsilon * 0.5) * 0.001
	rs_th_out = -ra / sin(lambda + epsilon * 0.5) * 0.001
	rs_km = rs_th * 0.001
	in = -1
	Nr = -1
	do i = 1, nbinta
	    if( radiita(i) .ge. 0.0 )then
		if(radiita(i) .lt. rs_th_in) in = i
		if(radiita(i) .le. rs_th_out) iout = i
		if(radiita(i) .le. rs_km) Nr = i
	    end if
	end do
	if(in .eq. -1)then
		write(6,*)' find_ground failure!'
		write(6,*)' ra:',ra
		write(6,*)'azm, phi: ', azm, phi
		write(6,*)'pitch, drift, roll: ',pitch, drift, roll
		write(6,*)'el, sin(lambda), lambda:',elev, 
     +			sn_lambda, lambda
		write(6,*)'rs_th_in, rs_th_out, rs_km:'
		write(6,*)rs_th_in, rs_th_out, rs_km
		write(6,*)' find_gs in, iout, Nr: ',in, iout, Nr
Cout		pause ' pausing for this mystery '
		ibeg = -1
		return
	end if
	Ng = iout - in + 1
	Ng2 =  0.5 * Ng
	if (Ng2 .eq. 0) Ng2 = 1
C changed radius of check to 30 bins = 2.25 km, because of huge
C range delays in Andrew 8 dec 92
C Then search the gates within +- 30 of gate at theoretical
C range to find the swath Ng/2 wide with greatest Total Ze.
C Return bounding bins.
	dBz_max = -1.0
	ibeg = -1
	ist = max(1, Nr - 30)
	ien = min(nbinta-Ng2, Nr + 30 -Ng2)
Coutd	write(6,*)'find_gd ist, ien: ',ist, ien
	do i = ist, ien
	   dBzsum = 0.0
	   do j = i, i + Ng2
		dBzsum = dBzsum + dbzbuffer(j)
	   end do
	   if( dBzsum .gt. dBz_max)then
		dBz_max = dBzsum
		ibeg = i
	   end if
	end do
	iradius = ibeg + Ng2 * 0.5
	if( iradius .le.0) iradius = 1
	rs_m = radiita( iradius ) * 1000.0
	return
	end
C following is swiped from the
C file gamache_pailsanglecor.f
C
      SUBROUTINE ANGLECOR(pitch, drift, roll, azm, elev, idradar,
     +  pcor, dcor, rcor, azmcor, elcor)
C     CORRECTS AIRCRAFT AZM AND ELEV ANGLES FOR PITCH, DRIFT, AND ROLL.  THE
C     RESULTING AZIMUTH AND ELEVATION ANGLES ARE RELATIVE TO AIRCRAFT TRACK.
C     SEE AIRBORNE RADAR GEOMETRY NOTES BY PETER DODGE.
      DATA             ctr/0.01745329/

C     MAKE DESIRED CORRECTIONS TO RAW PITCH, DRIFT, ROLL, AZIMUTH, AND ELEVATION
C     PITCH ANGLE >0=POINTING UP, <0 POINTING DOWN
C     DRIFT >0=HEADING LEFT OF TRACK, <0 HEADING RIGHT OF TRACK
C     ROLL ANGLE CORRECTION IN DEG. (+ CLOCKWISE - DIP STARBOARD WING)
C     AZMCOR > 0:CLOCKWISE, <0:COUNTERCLOCKWISE
C     ELCOR IS THE ELEVATION ANGLE CORRECTION (>0:FORWARD, <0:AFT)
      pitch = pitch + pcor
      drift = drift + dcor
      roll = roll + rcor
      azm = AMOD(azm + azmcor + 360.0, 360.0)
      elev = elev + elcor

C     CALCULATE FUNCTIONS USED REPEATEDLY
      cel = COS(elev * ctr)
      sel = SIN(elev * ctr)
      cpt = COS(pitch * ctr)
      spt = SIN(pitch * ctr)
      cdr = COS(drift * ctr)
      sdr = SIN(drift * ctr)

C     COMPUTE GEOMETRY FOR THE TAIL ANTENNA FIRST
      IF (idradar.EQ.2) THEN
C       CALCULATE OTHER FUNCTIONS USED REPEATEDLY HERE
C       CORRECT AZIMUTH FOR ROLL
        razm = AMOD(azm + roll + 360.0, 360.0) 
        caz = COS(razm * ctr)
        saz = SIN(razm * ctr)

C       SINE IS THE SIN OF THE CORRECTION ANGLE TO GET TAIL ANTENNA
C       PERPENDICULAR TO THE AIRCRAFT TRACK 
        sine = sel * cpt * cdr - cel * caz * spt * cdr + cel * saz * sdr

C       ELEVATION(RELATIVE TO A/C HEADING) (>0 POINTS FORWARD, <0 POINTING AFT)
        elev = ASIN(sine) / ctr

C       COMPUTE EARTH RELATIVE AZIMUTH FROM THE PLANE RELATIVE AZIMUTH      
        bigy = cel * cdr * saz - sdr * (sel * cpt - cel * spt * caz)  ! CPT CHANGED FROM SPT (P.DODGE 6FEB92)
        bigz = sel * spt + cel * cpt * caz
        azm = ATAN2(bigy, bigz) / ctr
c        write(6,*)'anglecor1,azm,bigy,bigz = ',azm,bigy,bigz
        IF (azm.LT.0.0)  azm = 360.0 + azm

      ELSE  ! COMPUTE THE GEOMETRY FOR THE LOWER FUSELAGE RADAR
C       CALCULATE OTHER FUNCTIONS USED REPEATEDLY - AZIMUTH NOT CORRECTED FOR ROLL
        caz = COS(azm * ctr)
        saz = SIN(azm * ctr)
        crl = COS(roll * ctr)
        srl = SIN(roll * ctr)

C       NOW AZIMUTH IS RELATIVE TO HEADING OR TRACK(0 IS FORWARD, 90 IS RIGHT)
        sdr = -sdr
        bigx = cel * caz * cpt * cdr +
     +    cel * saz * (srl * spt * cdr - crl * sdr) -
     +    sel * (crl * spt * cdr + srl * sdr)
        bigy = cel * caz * cpt * sdr +
     +    cel * saz * (srl * spt * sdr + crl * cdr) -
     +    sel * (crl * spt * sdr - srl * cdr)
        bigz = - cel * caz * spt + cel * saz * srl * cpt -
     +    sel * crl * cpt

C       ELEVATION(RELATIVE TO AIRCRAFT) (<0 POINTS DOWNWARD, >0 POINTS UPWARD)
        elev = - ASIN(bigz) / ctr
        azm = ATAN2(bigy, bigx) / ctr
c        write(6,*)'anglecor1,azm,bigy,bigx = ',azm,bigy,bigx
        azm = AMOD(360.0 + azm, 360.0)
ccc        azm = ASIN(bigy / COS(elev * ctr)) / ctr
      ENDIF

      RETURN
      END 

